import os

def fault_codes_list(case):
    return {
    0 : "ALL CLEAR",
    1 : "SOMETHING WRONG",
    2 : "SOMETHING BAD",
    3 : "SOMETHING OOPS",
    4 : "SOMETHING MISSING",
    5 : "CAN'T UNDERSTAND",
    6 : "GREAT CODE!",
    7 : "THE ROOF IS ON FIRE!",
    8 : "...",
    9 : "...",
    91 : "..."
    }.get(case, "UNKNOWN ERROR")

def error_codes_list(case):
    return {
     0 : "ALL CLEAR",
    -1 : "ILLEGAL_FUNCTION",
    -2 : "ILLEGAL_DATA_ADDRESS",
    -3 : "ILLEGAL_DATA_VALUE",
    -4 : "SLAVE_DEVICE_FAILURE",
    -5 : "ACKNOWLEDGE",
    -6 : "SLAVE_DEVICE_BUSY",
    -7 : "NEGATIVE_ACKNOWLEDGE",
    -8 : "MEMORY_PARITY_ERROR",
    -10 : "GATEWAY_PROBLEM_PATH",
    -11 : "GATEWAY_PROBLEM_TARGET",
    -12 : "COMM_TIME_OUT",
    -13 : "PORT_SOCKET_FAILURE",
    -14 : "SELECT_FAILURE",
    -15 : "TOO_MANY_DATAS",
    -16 : "INVALID_CRC",
    -17 : "INVALID_EXCEPTION_CODE",
    }.get(case, "UKNOWN ERROR")

class HandlerClass:

    def on_fault_reset_pressed(self, widget, data = None):
        os.system("halcmd setp spindle-vfd.fault-reset true")

    def on_fault_code_hal_pin_changed(self, hal_pin, data = None):
        i = fault_codes_list(int(hal_pin.get()))        
        self.builder.get_object('fault-code-text').set_label("( %s )" % (i))

    def on_error_code_hal_pin_changed(self, hal_pin, data = None):
        i = error_codes_list(int(hal_pin.get()))        
        self.builder.get_object('error-code-text').set_label("( %s )" % (i))

    def __init__(self, halcomp, builder, useropts):
        self.builder = builder

def get_handlers(halcomp, builder, useropts):
    return [HandlerClass(halcomp, builder, useropts)]

